<template>
  <v-dialog
    v-model="show"
    max-width="400"
  >
    <v-card>
      <v-form
        ref="form"
        v-model="formIsValid"
        lazy-validation
        @submit.prevent="submitChange"
      >
        <v-card-title class="title">
          Change your password
        </v-card-title>
        <v-card-text>
          <v-text-field
            v-model="currentPassword"
            label="Current password"
            type="password"
            autofocus
            required
            :error-messages="oldPasswordRejected ? 'Wrong password.' : undefined"
            :rules="[ rules.required ]"
            @input="oldPasswordRejected = false"
          />
          <v-text-field
            v-model="newPassword"
            label="New password"
            type="password"
            required
            :error-messages="newPasswordErrors"
            :rules="[ rules.required ]"
            @input="newPasswordErrors = null"
          />
          <v-text-field
            v-model="newPasswordRepeated"
            label="Repeat new password"
            type="password"
            required
            :rules="[ rules.required, rules.matchesPassword ]"
          />
          <v-alert
            type="error"
            :value="errorAlert !== null"
          >
            {{ errorAlert }}
          </v-alert>
        </v-card-text>
        <v-card-actions class="justify-end">
          <v-btn
            text
            color="primary"
            @click="$emit('hide')"
          >
            Cancel
          </v-btn>
          <v-btn
            :disabled="!formIsValid"
            text
            color="primary"
            type="submit"
          >
            Change password
          </v-btn>
        </v-card-actions>
      </v-form>
    </v-card>
  </v-dialog>
</template>

<script>
import { mapState } from 'vuex'
import { changePassword } from '@/api'
import { Authentication } from '@/store/modules/authentication'
import { required } from '@/util/form-rules'

export default {
  name: 'PasswordChangeDialog',
  data () {
    return {
      show: true,
      currentPassword: '',
      newPassword: '',
      newPasswordRepeated: '',
      formIsValid: false,
      rules: {
        required,
        matchesPassword: v => v === this.newPassword || 'Passwords do not match.',
      },
      errorAlert: null,
      oldPasswordRejected: false,
      newPasswordErrors: null
    }
  },
  computed: {
    userPk () { return Authentication.state.user.pk }
  },
  watch: {
    show (val) {
      if (!val) {
        this.$emit('hide')
      }
    },
    newPassword () {
      if (this.newPasswordRepeated !== '')
        this.$refs.form.validate()
    }
  },
  methods: {
    submitChange () {
      if (!this.$refs.form.validate())
        return

      const data = {
        oldPassword: this.currentPassword,
        newPassword: this.newPassword
      }
      changePassword(this.userPk, data).then(() => {
        this.$notify({
          title: 'Success!',
          text: 'Successfully changed password!',
          type: 'success'
        })
        this.$emit('hide')
      }).catch(error => {
        if (error.response && error.response.status === 401) {
          this.oldPasswordRejected = true
          this.$refs.form.validate()
          return
        }

        if (error.response && error.response.data && error.response.data.newPassword) {
          this.newPasswordErrors = error.response.data.newPassword
          return
        }

        this.errorAlert = error.toString()
      })
    }
  }
}
</script>

<style scoped>

</style>
